package jp.gihyo.wicket;

import jp.gihyo.wicket.page.ajax.AjaxTimeline;
import org.apache.wicket.Page;
import org.apache.wicket.Request;
import org.apache.wicket.Response;
import org.apache.wicket.Session;
import org.apache.wicket.protocol.http.WebApplication;

/**
 * Application object for your web application. If you want to run this application without deploying, run the Start class.
 * 
 * @see jp.javelindev.wicket.Start#main(String[])
 */
public class WicketApplication extends WebApplication {

    String consumerKey;
    String consumerSecret;

    /**
     * Constructor
     */
    public WicketApplication() {
    }

    /**
     * @see org.apache.wicket.Application#getHomePage()
     */
    public Class<? extends Page> getHomePage() {
        return AjaxTimeline.class;
    }

    @Override
    protected void init() {
        super.init();

        this.consumerKey = getInitParameter("twitter-consumer-key");
        this.consumerSecret = getInitParameter("twitter-consumer-secret");
        if(consumerKey == null) throw new IllegalStateException("'twitter-consumer-key' is missing in init-param of wicketFilter.");
        if(consumerSecret == null) throw new IllegalStateException("'twitter-consumer-secret' is missing in init-param of wicketFilter.");


        mountBookmarkablePage("/ajax", AjaxTimeline.class);
        mount(new LoginProcessorUrlCodingStrategy("/login"));

        getRequestCycleSettings().setGatherExtendedBrowserInfo(true);
    }

    @Override
    public Session newSession(Request request, Response response) {
        return new AppSession(request);
    }

    public String getConsumerKey() {
        return this.consumerKey;
    }

    public String getConsumerSecret() {
        return this.consumerSecret;
    }
}
